{ ... } @ args:
let
  gitpkgs = import /home/steveej/src/github/NixOS/nixpkgs {};
  unstablepkgs = import <nixos-unstable> {};

in {
  # required by nox
  permittedInsecurePackages = [
    "linux-4.13.16"
  ];

  allowBroken = true;

  chromium = {
    enablePepperFlash = true;
    enablePepperPDF = true;
  };

  firefox = {
    enableGoogleTalkPlugin = true;
    enableAdobeFlash = false;
  };

  pidgin = {
    openssl = true;
    gnutls = true;
  };

  packageOverrides = stablepkgs: rec {

#    virtmanager = stablepkgs.virtmanager.overrideDerivation (oldAttrs: {
#      patchPhase = ''
#        sed -i "/'install_egg_info'/d" setup.py
#        sed -i "s|self.cli_usbredir = None|self.cli_usbredir = True|" virtManager/config.py
#      '';
#    });

#    labshell = (import (unstablepkgs.fetchFromGitHub {
#          owner = "htwg-syslab";
#          repo = "nix-expressions";
#          rev = "89040d81cf6147b1ebaae8eca059f4718400a01a";
#          sha256 = "1ci8xbbnj7bdcciq7ibqz8vfhs3ml7k4yx6m8f8whgwrhzk4c8wa";
#        }) { labshellExpressionsRemoteRev = "master"; }
#      ).labshell;
#     labshell
    busyboxStatic =  stablepkgs.busybox.override {
      enableStatic = true;
      extraConfig = ''
         CONFIG_STATIC y
         CONFIG_INSTALL_APPLET_DONT y
         CONFIG_INSTALL_APPLET_SYMLINKS n
       '';
    };

    dropbearStatic = stablepkgs.dropbear.override {
      enableStatic = true;
    };

    userPackages = with stablepkgs; buildEnv {
      name = "userPackages";
      paths = [
        patchelf
        nix-index

        busyboxStatic 
        #nixUnstable
        #nox
        unetbootin

        androidsdk

        #nixops
        git-crypt
        unstablepkgs.ansible2
        pijul

        picocom
        roxterm
        xorg.xbacklight
        coreutils
        lsof
        pavucontrol
        xscreensaver
        x11_ssh_askpass
        xdotool
        xdg_utils
        xdg-user-dirs

        exiv2
        htop

#        gnome3.nautilus
#        gnome3.gvfs
        #(with xfce; 
        #  thunar.override { thunarPlugins = [
        #    thunar_volman
        #    thunar-archive-plugin
        #  ];
        #})
        #xfce.gvfs
        #xfce.xfce4icontheme
        sshfsFuse
        xarchive
        p7zip
        zip
        unzip
        gzip

        python
        python3Packages.ipython
        python3
        jre
        openjdk


        gnupg
        pass
        qtpass
        yubikey-neo-manager
        yubikey-personalization
        yubikey-personalization-gui

        unstablepkgs.chromium
        unstablepkgs.firefox
        seafile-client
        grive2
        dropbox
        zathura
        thunderbird
        unstablepkgs.libreoffice

        pidgin
        hexchat
        gitpkgs.hunspellDicts.en-us
        gitpkgs.hunspellDicts.de-any
        aspellDicts.en
        aspellDicts.de
        unstablepkgs.skype
        #zoom-us

        virtmanager

#        gnome3.dconf
        qemu
        vagrant
        unstablepkgs.rkt
        python27Packages.docker_compose

        remmina
        freerdp
        x2goclient
        samba

        vlc
        audacity
        gitpkgs.spotify

        pdftk
        calibre
        imagemagick
#        gnome3.eog
        unstablepkgs.mendeley

        iptables
        nftables
        iperf
        bind

        unstablepkgs.vscode
        unstablepkgs.atom
        gimp
        inkscape
        plantuml
        umlet
        graphviz

#        bundler
#        bundix



        travis
        jq

#        pandoc
        unstablepkgs.texlive.combined.scheme-medium
#        perlPackages.YAMLTiny

#        gnome3.pomodoro

        ntfs3g
        ddrescue
        ncdu

        xorg.xhost
#        gitpkgs.wtftw
        autorandr
        arandr

#        numix-icon-theme
#        numix-gtk-theme
        gnome3.gnome_themes_standard
        gnome3.adwaita-icon-theme
        lxappearance
        xorg.xcursorthemes

        openssl
        mkpasswd

        hdparm
        testdisk
        wireshark


        # games
        zeroad


        # Compilers & Toolchains
        gcc
        pkgconfig
        binutils
        valgrind
        gdb
        cgdb
        man-pages
        gnumake

        nodejs
        emscripten

        ## Rust Development
        rustup
        capnproto
        kcov
      ];
    };
  };
}
